----------------------------------------------------------------------------
-- @Author: ViperGTS96------------------------------------------------------
----------------------------------------------------------------------------
--------------------"The simplest design is the best design." --------------
----------------------------------------------------------------------------
----------------------------------------------------------------------------

lightControl = {};
lightControl.modDirectory  = g_currentModDirectory;
local modDescFile = loadXMLFile("modDesc", lightControl.modDirectory .. "modDesc.xml");
lightControl.title = getXMLString(modDescFile, "modDesc.title.en");
lightControl.author = getXMLString(modDescFile, "modDesc.author");
lightControl.version = getXMLString(modDescFile, "modDesc.version");
delete(modDescFile);
lightControl.inputsXML = getUserProfileAppPath().. "inputBinding.xml";
lightControl.lightKey = "uninitialized";
lightControl.lowBeamKey = "uninitialized";
lightControl.highBeamKey = "uninitialized";
lightControl.fWorkLightsKey = "uninitialized";
lightControl.rWorkLightsKey = "uninitialized";
lightControl.beaconKey = "uninitialized";
lightControl.hazardKey = "uninitialized";
lightControl.signalLKey = "uninitialized";
lightControl.signalRKey = "uninitialized";
lightControl.lightKeyDown = false;
lightControl.lowBeamKeyDown = false;
lightControl.highBeamKeyDown = false;
lightControl.fWorkLightsKeyDown = false;
lightControl.rWorkLightsKeyDown = false;
lightControl.beaconKeyDown = false;
lightControl.hazardKeyDown = false;
lightControl.signalLKeyDown = false;
lightControl.signalRKeyDown = false;
lightControl.soundEnabled = false;
lightControl.toggleSound = createSample("toggleLightSound");
local file = g_currentModDirectory.."switch.ogg";

loadSample(lightControl.toggleSound, file, false);
function lightControl:playSound()
	playSample(lightControl.toggleSound, 1, 0.2, 0, 0, 0);
end;

function lightControl:onRegisterActionEvents(superFunc, isActiveForInput, isActiveForInputIgnoreSelection)
    if self.isClient then
        if self.getIsEntered ~= nil and self:getIsEntered() then
            local spec = self.spec_lights
            self:clearActionEventsTable(spec.actionEvents)
            if self:getIsActiveForInput(true, true) then
                _, spec.actionEventIdLight = self:addActionEvent(spec.actionEvents, InputAction.TOGGLE_LIGHTS, self, Lights.actionEventToggleLights, false, true, false, true, nil)
                local _, actionEventIdFront = self:addActionEvent(spec.actionEvents, InputAction.TOGGLE_LIGHT_FRONT, self, Lights.actionEventToggleLightFront, false, true, false, true, nil)
                local _, actionEventIdWorkBack = self:addActionEvent(spec.actionEvents, InputAction.TOGGLE_WORK_LIGHT_BACK, self, Lights.actionEventToggleWorkLightBack, false, true, false, true, nil)
                local _, actionEventIdWorkFront = self:addActionEvent(spec.actionEvents, InputAction.TOGGLE_WORK_LIGHT_FRONT, self, Lights.actionEventToggleWorkLightFront, false, true, false, true, nil)
                local _, actionEventIdHighBeam = self:addActionEvent(spec.actionEvents, InputAction.TOGGLE_HIGH_BEAM_LIGHT, self, Lights.actionEventToggleHighBeamLight, false, true, false, true, nil)
                self:addActionEvent(spec.actionEvents, InputAction.TOGGLE_TURNLIGHT_HAZARD, self, Lights.actionEventToggleTurnLightHazard, false, true, false, true, nil)
                self:addActionEvent(spec.actionEvents, InputAction.TOGGLE_TURNLIGHT_LEFT, self, Lights.actionEventToggleTurnLightLeft, false, true, false, true, nil)
                self:addActionEvent(spec.actionEvents, InputAction.TOGGLE_TURNLIGHT_RIGHT, self, Lights.actionEventToggleTurnLightRight, false, true, false, true, nil)
                local _, actionEventIdBeacon = self:addActionEvent(spec.actionEvents, InputAction.TOGGLE_BEACON_LIGHTS, self, Lights.actionEventToggleBeaconLights, false, true, false, true, nil)
                -- action events that are only active if getIsActiveForLights
                spec.actionEventsActiveChange = {actionEventIdFront, actionEventIdWorkBack, actionEventIdWorkFront, actionEventIdHighBeam, actionEventIdBeacon}
                for _,actionEvent in pairs(spec.actionEvents) do
                    if actionEvent.actionEventId ~= nil then
                        g_inputBinding:setActionEventTextVisibility(actionEvent.actionEventId, false)
                        g_inputBinding:setActionEventTextPriority(actionEvent.actionEventId, GS_PRIO_LOW)
                    end
                end
            end
        end
    end
end

function lightControl:getCanToggleLight(superFunc)
    local spec = self.spec_lights
    if spec.numLightTypes == 0 then
        return false
    end
    if g_currentMission.controlledVehicle == self then
        return true
    else
        return false
    end
end

function  lightControl:updateAILights(superFunc)
	local spec = self.spec_lights
	if self.spec_lights ~= nil then
		if self:getIsAIActive() then
			local dayMinutes = g_currentMission.environment.dayTime/(1000*60);
			local needLights = (dayMinutes > g_currentMission.environment.nightStartMinutes or dayMinutes < g_currentMission.environment.nightEndMinutes);
			if (needLights and self.aiNiteLiteUsed == nil) then
				if spec.lightsTypesMask <= 0 then -- Will turn on lights only 1 time during the night if they're off.
					local lightsTypesMask = bitXOR(spec.lightsTypesMask, 2^0);
					self:setLightsTypesMask(lightsTypesMask, true, false);
					lightsTypesMask = bitXOR(spec.lightsTypesMask, 2^1);
					self:setLightsTypesMask(lightsTypesMask, true, false);
					lightsTypesMask = bitXOR(spec.lightsTypesMask, 2^2);
					self:setLightsTypesMask(lightsTypesMask, true, false);
					self.aiNiteLiteUsed = true;
				end;
			elseif (not needLights and self.aiNiteLiteUsed ~= nil) then				
				self:setLightsTypesMask(0, true, false); -- Will turn off lights only 1 time during the day if they're still on from the night.
				self.aiNiteLiteUsed = nil;
			--elseif (not needLights and spec.lightsTypesMask <= 0) then
			--	self.aiNiteLiteUsed = nil; -- If Daytime and Player already turned off the Lights; the night light procedure is reset.
			end;
		elseif self.aiNiteLiteUsed then
			self.aiNiteLiteUsed = false; -- If Helper is dimissed; the night light procedure is reset.
		end;
	end;
end;

function lightControl:lightSounds()

	if Input.isKeyPressed(Input[lightControl.lightKey]) then
		if not lightControl.lightKeyDown then
			lightControl:playSound();
		end;
		lightControl.lightKeyDown = true;
	end;
				
	if Input.isKeyPressed(Input[lightControl.beaconKey]) then
		if not lightControl.beaconKeyDown then
			lightControl:playSound();
		end;
		lightControl.beaconKeyDown = true;
	end;
				
	if Input.isKeyPressed(Input[lightControl.lowBeamKey]) then
		if not lightControl.lowBeamKeyDown then
			lightControl:playSound();
		end;
		lightControl.lowBeamKeyDown = true;
	end;
				
	if Input.isKeyPressed(Input[lightControl.highBeamKey]) then
		if not lightControl.highBeamKeyDown then
			lightControl:playSound();
		end;
		lightControl.highBeamKeyDown = true;
	end;

	if Input.isKeyPressed(Input[lightControl.fWorkLightsKey]) then
		if not lightControl.fWorkLightsKeyDown then
			lightControl:playSound();
		end;
		lightControl.fWorkLightsKeyDown = true;
	end;
				
	if Input.isKeyPressed(Input[lightControl.rWorkLightsKey]) then
		if not lightControl.rWorkLightsKeyDown then
			lightControl:playSound();
		end;
		lightControl.rWorkLightsKeyDown = true;
	end;

	if Input.isKeyPressed(Input[lightControl.hazardKey]) then
		if not lightControl.hazardKeyDown then
			lightControl:playSound();
		end;
		lightControl.hazardKeyDown = true;
	end;
				
	if Input.isKeyPressed(Input[lightControl.signalLKey]) then
		if not lightControl.signalLKeyDown then
			lightControl:playSound();
		end;
		lightControl.signalLKeyDown = true;
	end;

	if Input.isKeyPressed(Input[lightControl.signalRKey]) then
		if not lightControl.signalRKeyDown then
			lightControl:playSound();
		end;
		lightControl.signalRKeyDown = true;
	end;
end;

function lightControl:stopKeysIfReleased()

		if not Input.isKeyPressed(Input[lightControl.lightKey]) and lightControl.lightKeyDown then
			lightControl.lightKeyDown = false;
		end;
		if not Input.isKeyPressed(Input[lightControl.beaconKey]) and lightControl.beaconKeyDown then
			lightControl.beaconKeyDown = false;
		end;
		if not Input.isKeyPressed(Input[lightControl.lowBeamKey]) and lightControl.lowBeamKeyDown then
			lightControl.lowBeamKeyDown = false;
		end;
		if not Input.isKeyPressed(Input[lightControl.highBeamKey]) and lightControl.highBeamKeyDown then
			lightControl.highBeamKeyDown = false;
		end;
		if not Input.isKeyPressed(Input[lightControl.fWorkLightsKey]) and lightControl.fWorkLightsKeyDown then
			lightControl.fWorkLightsKeyDown = false;
		end;
		if not Input.isKeyPressed(Input[lightControl.rWorkLightsKey]) and lightControl.rWorkLightsKeyDown then
			lightControl.rWorkLightsKeyDown = false;
		end;
		if not Input.isKeyPressed(Input[lightControl.hazardKey]) and lightControl.hazardKeyDown then
			lightControl.hazardKeyDown = false;
		end;
		if not Input.isKeyPressed(Input[lightControl.signalLKey]) and lightControl.signalLKeyDown then
			lightControl.signalLKeyDown = false;
		end;
		if not Input.isKeyPressed(Input[lightControl.signalRKey]) and lightControl.signalRKeyDown then
			lightControl.signalRKeyDown = false;
		end;	

end;

function lightControl:loadMap(savegame)
	lightControl:setKeys();
end;

function lightControl:update(dt)
	if g_gui:getIsGuiVisible() and lightControl.controlsChanged == nil then -- Reload Key Configuration 
		lightControl.controlsChanged = true;
	elseif lightControl.controlsChanged ~= nil and not g_gui:getIsGuiVisible() then		
		lightControl:setKeys();
		lightControl.controlsChanged = nil;
	end;	
	lightControl:lightSounds();
	lightControl:stopKeysIfReleased();
end;

function lightControl:setKeys()

	local xmlFile = loadXMLFile("inputBinding", lightControl.inputsXML)
	
	local i = 0;
	local iCount = 0;
	while true do
		local objKey = string.format("inputBinding.actionBinding(%d)", i);
		local inputKey = getXMLString(xmlFile, objKey.."#action")
		if inputKey == nil or iCount >= 9 then
			break;
		end;
		if inputKey == "TOGGLE_LIGHTS" then
			lightControl.lightKey = getXMLString(xmlFile, objKey.. ".binding#input")
			iCount = iCount + 1;
		end;
		if inputKey == "TOGGLE_BEACON_LIGHTS" then
			lightControl.beaconKey = getXMLString(xmlFile, objKey..".binding#input")
			iCount = iCount + 1;
		end;
		if inputKey == "TOGGLE_TURNLIGHT_LEFT" then
			lightControl.signalLKey = getXMLString(xmlFile, objKey..".binding#input")
			iCount = iCount + 1;
		end;
		if inputKey == "TOGGLE_TURNLIGHT_RIGHT" then
			lightControl.signalRKey = getXMLString(xmlFile, objKey..".binding#input")
			iCount = iCount + 1;
		end;
		if inputKey == "TOGGLE_TURNLIGHT_HAZARD" then
			lightControl.hazardKey = getXMLString(xmlFile, objKey..".binding#input")
			iCount = iCount + 1;
		end;
		if inputKey == "TOGGLE_WORK_LIGHT_BACK" then
			lightControl.rWorkLightsKey = getXMLString(xmlFile, objKey..".binding#input")
			iCount = iCount + 1;
		end;
		if inputKey == "TOGGLE_WORK_LIGHT_FRONT" then
			lightControl.fWorkLightsKey = getXMLString(xmlFile, objKey..".binding#input")
			iCount = iCount + 1;
		end;
		if inputKey == "TOGGLE_HIGH_BEAM_LIGHT" then
			lightControl.highBeamKey = getXMLString(xmlFile, objKey..".binding#input")
			iCount = iCount + 1;
		end;
		if inputKey == "TOGGLE_LIGHT_FRONT" then
			lightControl.lowBeamKey = getXMLString(xmlFile, objKey..".binding#input")
			iCount = iCount + 1;
		end;
        i = i + 1;
    end;

end;

Lights.onRegisterActionEvents = Utils.overwrittenFunction(Lights.onRegisterActionEvents, lightControl.onRegisterActionEvents);
Lights.getCanToggleLight = Utils.overwrittenFunction(Lights.getCanToggleLight, lightControl.getCanToggleLight);
Lights.updateAILights = Utils.overwrittenFunction(Lights.updateAILights, lightControl.updateAILights);
print("Load mod: "..lightControl.title.." : v"..lightControl.version.." by "..lightControl.author);
addModEventListener(lightControl);